package com.sillycycle.bagleyd.welltris;

// Learned a lot here
// http://www.edu4java.com/en/androidgame/androidgame1.html
import com.sillycycle.bagleyd.util.Colour;

import android.annotation.SuppressLint;
import android.content.Context;
//import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Color;
//import android.graphics.Point;
//import android.graphics.Paint;
//import android.graphics.Rect;
import android.view.MotionEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;

@SuppressLint("WrongCall")
public class GameView extends SurfaceView {
    GameLoopThread gameLoopThread;
    private long lastClick;
    //private Bitmap bmpGame;
    //private int count = 1;

    private int yDropSpeed = 10;
    private int yFallSpeed = 1;
	//private Paint fillPaint = new Paint();
	//private Rect fillRect = new Rect();
	PolyominoImage polyominoImage = new PolyominoImage();
	ThingView thingView = new ThingView();
	int currentSpeed = yFallSpeed;
	int flashCount = 2 * WelltrisInterface.NUM_FLASHES + 1;
	boolean skip = true;
	int fill = -1;

    public GameView(Context context) {
	super(context);
	gameLoopThread = new GameLoopThread(this);

	getHolder().addCallback(new SurfaceHolder.Callback() {
		@Override
		public void surfaceDestroyed(SurfaceHolder holder) {
			boolean retry = true;
			gameLoopThread.setRunning(false);
			while (retry) {
				try {
					gameLoopThread.join();
					retry = false;
				} catch (InterruptedException e) {
					return;
				}
			}
		}

		@Override
		public void surfaceCreated(SurfaceHolder holder) {
			//create stuff
			gameLoopThread.setRunning(true);
			gameLoopThread.start();
		}

		@Override
		public void surfaceChanged(SurfaceHolder holder, int format,
				int width, int height) {
			//create stuff again for resize
			int relativeWidth = getWidth() / WelltrisInterface.DEFAULT_WIDTH;
			int relativeHeight = getHeight() / WelltrisInterface.DEFAULT_WIDTH;
			int size = alignUnits(relativeWidth, relativeHeight);

			polyominoImage.createBitmaps(false, false,
					size, new Colour(Colour.black));
			fill = -1;
			skip = true;
			currentSpeed = yFallSpeed;
			thingView.initFill(true, 2);
			polyominoImage.setPlainPiece(false);
		}
	  });
	  //bmp = BitmapFactory.decodeResource(getResources(), R.drawable.tetris);
       }

       @Override
       protected void onDraw(Canvas canvas) {
		//int width = bmp.getWidth();
		int relativeWidth = getWidth() / (3 * WelltrisInterface.DEFAULT_WIDTH);
		int relativeHeight = getHeight() / (3 * WelltrisInterface.DEFAULT_WIDTH);
		int size = alignUnits(relativeWidth, relativeHeight);
		int gameWidth = size * WelltrisInterface.DEFAULT_WIDTH;
		int gameHeight = size * WelltrisInterface.DEFAULT_WIDTH;
		int offsetX = (getWidth() - 3 * gameWidth) / 2;
		int offsetY = (getHeight() - 3 * gameHeight) / 2;

		if (canvas == null)
			return;
		canvas.drawColor(Color.BLACK);

		thingView.setBoxSize(size);
		thingView.setOffset(offsetX, offsetY);
		thingView.drawBorder(canvas);

	   if (thingView.allFrozen(canvas, polyominoImage) && fill < 0 ||
			fill >= WelltrisInterface.DEFAULT_DEPTH
			+ WelltrisInterface.DEFAULT_WIDTH) {
		fill = 0;
	   }
	   if (fill >= 0) {
		thingView.unfreezeWalls();
		thingView.fillLines(canvas, polyominoImage, fill);
		thingView.drawField(canvas, polyominoImage);
		fill++;
			 return;
	   }
	   if (flashCount <= 2 * WelltrisInterface.NUM_FLASHES) {
		   if (flashCount == 2 * WelltrisInterface.NUM_FLASHES) {
			   thingView.shrinkLines(canvas, polyominoImage);
			   thingView.drawField(canvas, polyominoImage);
			   flashCount++;
			   thingView.setNextThing();
			   skip = true;
			   thingView.checkFreeze(canvas, polyominoImage);
			   if (thingView.overlapping()) {
				   fill = 0;
				   currentSpeed = yDropSpeed;
				   return;
			   }
			   return;
		   }
		   thingView.drawField(canvas, polyominoImage);
		   if (flashCount % 2 == 0)
			   thingView.invertLines(canvas, polyominoImage);
		   flashCount++;
		   return;
	   }
	   if (skip) {
		   skip = false;
	   } else {
		   if (!thingView.move(0, 1)) {
			   thingView.putUnit();
			   currentSpeed = yFallSpeed;
			   if (thingView.checkLines() > 0) {
				   flashCount = 0;
				   thingView.drawField(canvas, polyominoImage);
				   return;
			   }
			   thingView.setNextThing();
			   skip = true;
			   thingView.checkFreeze(canvas, polyominoImage);
			   if (thingView.overlapping()) {
				   fill = 0;
				   currentSpeed = yDropSpeed;
				   return;
			   }
		   }
	   }
	   thingView.drawField(canvas, polyominoImage);
	   thingView.drawThing(canvas, polyominoImage);
	   // if grid
	   thingView.drawGrid(canvas);

       }

       @Override
       public boolean onTouchEvent(MotionEvent event) {
	   if (System.currentTimeMillis() - lastClick > 300) {
	       lastClick = System.currentTimeMillis();
	       int boxSize = thingView.getBoxSize();
	       int offsetX = thingView.getOffsetX();
	       int offsetY = thingView.getOffsetY();
	       float touchX = event.getX();
	       float touchY = event.getY();
	       int newX = ((int) (touchX - offsetX)) / (boxSize * WelltrisInterface.DEFAULT_WIDTH);
	       int newY = ((int) (touchY - offsetY)) / (boxSize * WelltrisInterface.DEFAULT_WIDTH);

	       if (newX <= 0 && newY <= 0 || newX > 1 && newY > 1) {
			thingView.move(-1, 0);
			return false;
	       } else if (newX > 1 && newY <= 0 || newX <= 0 && newY > 1) {
			thingView.move(1, 0);
			return false;
	       }
	       /*if (thingView.isCollision(newX, newY))*/
	       if (newX == 1 && newY == 1) {
		   if (currentSpeed != yDropSpeed)
			currentSpeed = yDropSpeed;
	       } else {
			synchronized (getHolder()) {
				thingView.rotate();
			}
			performClick();
			return true;
		}
	   }
	   return false;
	}

       @Override
       public boolean performClick() {
	   super.performClick();
	   // Handle the action for the custom click here
	   return true;
       }

       static int alignUnits(int width , int height) {
	   if (width < height) {
		   return (width >> 2) << 2;
	   }
	   return (height >> 2) << 2;
       }

       public int speed() {
	   return currentSpeed;
       }
}
